Dim Manager

Set Manager = CreateObject("TopalServerAPI.Manager") 'Create Topal API COM object
Dim ip, userName, userPass, clientName, fiscalYear, partyNum, found, vatCode, costCenterCode

ip = "localhost"
userName = "TopUser"
userPass = ""
clientName = "Mon Bijou AG"
fiscalYear = "2012"
partyNum = 1000
vatCode = "UStn"
costCenterCode = "100"

manager.UseDefaults = true

Dim errCode
Dim message
Dim logined

'Login to Topal server

logined = Manager.Login( ip, userName, userPass, message) 'returns true  if login was successful
if (logined) then
  MsgBox("Connected successfully") 
else
  MsgBox(message)'Show error message if not logined
end if 

'Set current client client
found = false
Manager.Clients.Reset()
While Manager.Clients.MoveNext()
  Set currClient = Manager.Clients.Current
  If currClient.Name = clientName Then   
      errCode = Manager.SetGlobalClient(currClient)
	  if (errCode <> 0) then
		MsgBox(Manager.GetErrorMessage(errCode))
	  else
		MsgBox("client succesfully set")
		found = true
	  end if
  End if
Wend

if(found = false) then
	MsgBox("client not found")
end if

'Set current fiscal year
Manager.Client.FiscalYears.Reset()
While Manager.Client.FiscalYears.MoveNext()
  Set currFY = Manager.Client.FiscalYears.Current
  If currFY.Name = fiscalYear Then   
      errCode = Manager.SetGlobalFiscalYear(currFY)
	  if (errCode <> 0) then
		MsgBox(Manager.GetErrorMessage(errCode))
	  else
		MsgBox("fiscal year succesfully set")
	  end if
  End if
Wend



'create invoice
Dim party
'search for party to set invoice.PartyFID
errCode = Manager.FindParty(partyNum, party)

if (errCode <> 0) then
	MsgBox(Manager.GetErrorMessage(errCode))
end if

Set invoice = CreateObject("TopalServerAPI.Invoice")
invoice.FreeInvoiceNum = "free1"' we can set FreeInvoice#
invoice.InvoiceDate = "19.09.2012" ' by default - current date
invoice.PartyFID = party.ID
invoice.PersonRoleFID = 2 '2=Debitor, 3=Creditor 'mandatory
invoice.Text = "Test Invoice"
invoice.TotalAmount = 5.25 'mandatory
invoice.Transaction.DocDate = "19.09.2012"' by default - current date

Set posting1 = CreateObject("TopalServerAPI.Posting") 
posting1.AccountFID = party.Debtor.Paymethods.GetItem(0).AccountFID
posting1.Text = "first posting"
posting1.FreeCode = "Free 1"
posting1.Amount = 5.25
posting1.IsDebit = True
posting1.PostingTypeFID = 2 '1=Sammelrechnung, 2=Rechnung, 3=Zahlung, 4=Gutschrift 
invoice.Transaction.Postings.Add(posting1) 

'create posting with VAT
set posting2 = CreateObject("TopalServerAPI.Posting") 
posting2.AccountFID = party.Debtor.AccountFID
posting2.Text = "VAT posting"
posting2.IsDebit = False
posting2.PostingTypeFID = 2 '1=Sammelrechnung, 2=Rechnung, 3=Zahlung, 4=Gutschrift 

'find VAT by code

Dim vat
Set vat = Manager.FindVAT(vatCode)

if( vat is Nothing) then
	MsgBox("VAT not found")
end if

'now we can fill amount of posting with VAT
'for that we give posting VAT and amounts in key currency and foreign currency (for key currency posting amounts are the same)
Manager.FillVATPostingAmount posting2, vat, 5.25, 5.25
invoice.Transaction.Postings.Add(posting2) 

'create Cost Center  posting
set postingCC = CreateObject("TopalServerAPI.Posting") 
postingCC.AccountFID = posting2.AccountFID
postingCC.Text = "Cost center posting"
postingCC.IsDebit = False
postingCC.Amount = posting2.Amount
postingCC.PostingTypeFID = 8 '8=CostCenter 

'find CostCenter by code
Dim costCenter
Set costCenter = Manager.FindCostCenter(costCenterCode)
if (costCenter is Nothing) then
	MsgBox("CostCenter not found")
end if
postingCC.costCenterFID = costCenter.ID
invoice.Transaction.Postings.Add(postingCC) 

'save invoice
errCode = Manager.SaveInvoice(invoice)
if (errCode <> 0) then
 MsgBox(Manager.GetErrorMessage(errCode))
else
 MsgBox("invoice# of created invoice: " & Invoice.invoiceNum)
end if 

'Logout and close connection
errCode = Manager.Logout()
if (errCode <> 0) then
	MsgBox(Manager.GetErrorMessage(errCode))
else
	MsgBox("logout succesfully")
end if

Manager.Close()