Dim Manager

Set Manager = CreateObject("TopalServerAPI.Manager") 'Create Topal API COM object
Dim ip, userName, userPass, clientName, tmAccountCode, found

ip = "localhost"
userName = "TopUser"
userPass = ""
clientName = "Mon Bijou AG"
tmAccountCode = "1100"

Dim errCode
Dim message
Dim logined

'Login to Topal server
logined = Manager.Login( ip, userName, userPass, message) 'returns true  if login was successful

if (logined) then
  MsgBox("Connected successfully") 
else
  MsgBox(message)'Show error message if not logined
end if 

'Set current client client
found = false
Manager.Clients.Reset()

While Manager.Clients.MoveNext()
  Set currClient = Manager.Clients.Current
  If currClient.Name = clientName Then   
      Manager.SetGlobalClient(currClient)
	  if (errCode <> 0) then
		MsgBox(Manager.GetErrorMessage(errCode))
	  else
		MsgBox("client succesfully set")
		found = true
	  end if
  End if
Wend

if(found = false) then
	MsgBox("client not found")
end if

'Create Party
Set party = CreateObject("TopalServerAPI.Party") 
'Set mandatory fields
'we can not set party number and it will be asigned automatically
party.Name = "Party from API"
party.ShortName = "PAPI"
party.FreePartyNum = "free123" 'we can set free party#
party.Person.FirstName = "Some name" 'set party contact person info (not manadatory)

errCode = Manager.SaveParty(party)
if (errCode <> 0) then
 MsgBox(Manager.GetErrorMessage(errCode))
else
 MsgBox("party saved succesfully")
end if

'Create Debtor
Set debtor = CreateObject("TopalServerAPI.Debtor") 
debtor.PartyFID = party.ID 'assign debtor party link
debtor.Person.FirstName = "Debtor name" 

'set payment term
errCode = Manager.LoadPayTerms()
if (errCode <> 0) then
 MsgBox(Manager.GetErrorMessage(errCode))

While Manager.PayTerms.MoveNext()
  Set currPT = Manager.PayTerms.Current
  If currPT.DueDays = 0 Then   
     debtor.payTermFID = currPT.ID
  End if
Wend

'create transaction method
'find an account
errCode = Manager.LoadAccounts()
if (errCode <> 0) then
 MsgBox(Manager.GetErrorMessage(errCode))

end if

Set account = Manager.FindAccount(tmAccountCode)
Dim paymethod
Set paymethod = CreateObject("TopalServerAPI.PayMethod")

paymethod.Name = "PM from API"
paymethod.AccountFID = account.ID 'set link to account
paymethod.PayTypeFID = 5 'ESR = 1,RoterESBank = 2, RoterESPost = 3, RoterESTreuhand = 4, LSV = 5, Manual = 6, Postmandant = 7, Fremdwauhrung = 8, IBAN
paymethod.PersonRoleFID = 2 '2 = Debtor, 3 = Creditor
debtor.Paymethods.add(paymethod)

errCode = Manager.SaveDebtor(debtor)

if (errCode <> 0) then
 MsgBox(Manager.GetErrorMessage(errCode))
else
 MsgBox("debtor saved succesfully")
end if

'Logout and close connection
errCode = Manager.Logout()
if (errCode <> 0) then
 MsgBox(Manager.GetErrorMessage(errCode))
 else
	MsgBox("logout succesfully")
end if

Manager.Close()