Dim Manager

Set Manager = CreateObject("TopalServerAPI.Manager") 'Create Topal API COM object

Dim ip, userName, userPass, clientName, fiscalYear, partyNum, found, vatCode, invoice1Num, invoice2Num



ip = "localhost"

userName = "apiUser"

userPass = ""

clientName = "Mon Bijou AG"

fiscalYear = "2012"

partyNum = 1000

vatCode = "UStn"



manager.UseDefaults = true

Dim errCode

Dim message

Dim logined

'Login to Topal server

logined = Manager.Login( ip, userName, userPass, message) 'returns true  if login was successful

if (logined) then

  MsgBox("Connected successfully") 

else

  MsgBox(message)'Show error message if not logined

end if 



'Set current client client

found = false

Manager.Clients.Reset()

While Manager.Clients.MoveNext()

  Set currClient = Manager.Clients.Current

  If currClient.Name = clientName Then   

      errCode = Manager.SetGlobalClient(currClient)

	  if (errCode <> 0) then

		MsgBox(Manager.GetErrorMessage(errCode))

	  else

		MsgBox("client succesfully set")

		found = true

	  end if

  End if

Wend



if(found = false) then

	MsgBox("client not found")

end if



'Set current fiscal year

Manager.Client.FiscalYears.Reset()

While Manager.Client.FiscalYears.MoveNext()

  Set currFY = Manager.Client.FiscalYears.Current

  If currFY.Name = fiscalYear Then   

      errCode = Manager.SetGlobalFiscalYear(currFY)

	  if (errCode <> 0) then

		MsgBox(Manager.GetErrorMessage(errCode))

	  else

		MsgBox("fiscal year succesfully set")

	  end if

  End if

Wend





' ----------------------- create invoice ---------------------------------------

Dim party

'search for party to set invoice.PartyFID

errCode = Manager.FindParty(partyNum, party)

if (errCode <> 0) then

	MsgBox(Manager.GetErrorMessage(errCode))

end if



Set invoice = CreateObject("TopalServerAPI.Invoice")

invoice.FreeInvoiceNum = "free1"' we can set FreeInvoice#

invoice.InvoiceDate = "19.09.2012" ' by default - current date

invoice.PartyFID = party.ID

invoice.PersonRoleFID = 2 '2=Debitor, 3=Creditor 'mandatory

invoice.Text = "Test Invoice"

invoice.TotalAmount = 5.25 'mandatory

invoice.Transaction.DocDate = "19.09.2012"' by default - current date



Set posting1 = CreateObject("TopalServerAPI.Posting") 

posting1.AccountFID = party.Debtor.Paymethods.GetItem(0).AccountFID

posting1.Text = "Test 123"

posting1.FreeCode = "Free 1"

posting1.Amount = 5.25

posting1.IsDebit = True

posting1.PostingTypeFID = 2 '1=Sammelrechnung, 2=Rechnung, 3=Zahlung, 4=Gutschrift 

invoice.Transaction.Postings.Add(posting1) 



set posting2 = CreateObject("TopalServerAPI.Posting") 

posting2.AccountFID = party.Debtor.AccountFID

posting2.Text = "Test 22"

posting2.IsDebit = False

posting2.PostingTypeFID = 2 '1=Sammelrechnung, 2=Rechnung, 3=Zahlung, 4=Gutschrift 

'find VAT by code

Set vat = Manager.FindVAT(vatCode)

if(vat = NULL) then

	MsgBox("VAT not found")

end if



'now we can fill amount of posting with VAT

Manager.FillVATPostingAmount posting2, vat, 5.25, 5.25

invoice.Transaction.Postings.Add(posting2) 



'save invoice

errCode = Manager.SaveInvoice(invoice)

if (errCode <> 0) then

 MsgBox(Manager.GetErrorMessage(errCode))

else

 invoice1Num = Invoice.invoiceNum

 MsgBox("invoice# of created invoice: " & invoice1Num)

end if 



' ----------------------- create credit note ---------------------------------------

'search for party to set invoice.PartyFID

errCode = Manager.FindParty(partyNum, party)

if (errCode <> 0) then

	MsgBox(Manager.GetErrorMessage(errCode))

end if



Set invoice = CreateObject("TopalServerAPI.Invoice")

invoice.FreeInvoiceNum = "free1"' we can set FreeInvoice#

invoice.InvoiceDate = "19.09.2012" ' by default - current date

invoice.PartyFID = party.ID

invoice.PersonRoleFID = 2 '2=Debitor, 3=Creditor 'mandatory

invoice.Text = "Test Invoice"

invoice.TotalAmount = -5.25 'mandatory

invoice.Transaction.DocDate = "19.09.2012"' by default - current date



Set posting1 = CreateObject("TopalServerAPI.Posting") 

posting1.AccountFID = party.Debtor.Paymethods.GetItem(0).AccountFID

posting1.Text = "Test 123"

posting1.FreeCode = "Free 1"

posting1.Amount = 5.25

posting1.IsDebit = False

posting1.PostingTypeFID = 2 '1=Sammelrechnung, 2=Rechnung, 3=Zahlung, 4=Gutschrift 

invoice.Transaction.Postings.Add(posting1) 



set posting2 = CreateObject("TopalServerAPI.Posting") 

posting2.AccountFID = party.Debtor.AccountFID

posting2.Text = "Test 22"

posting2.IsDebit = True

posting2.PostingTypeFID = 2 '1=Sammelrechnung, 2=Rechnung, 3=Zahlung, 4=Gutschrift 

'find VAT by code

Set vat = Manager.FindVAT(vatCode)

if(vat = NULL) then

	MsgBox("VAT not found")

end if



'now we can fill amount of posting with VAT

Manager.FillVATPostingAmount posting2, vat, 5.25, 5.25

invoice.Transaction.Postings.Add(posting2) 



'save invoice

errCode = Manager.SaveInvoice(invoice)

if (errCode <> 0) then

 MsgBox(Manager.GetErrorMessage(errCode))

else

 invoice2Num = Invoice.invoiceNum

 MsgBox("invoice# of created creditNote: " & invoice2Num)

end if 







' ----------------------- create manual payment ---------------------------------------

Dim invoice1, invoice2, paymentAccCode

paymentAccCode = "1020"



'search for invoices

errCode = Manager.FindInvoice(invoice1Num, true, invoice1)'if debtor = true, creditor = false

if (errCode <> 0) then

 MsgBox(Manager.GetErrorMessage(errCode))

end if



errCode = Manager.FindInvoice(invoice2Num, true, invoice2)'if debtor = true, creditor = false

if (errCode <> 0) then

 MsgBox(Manager.GetErrorMessage(errCode))

end if



Set payment = CreateObject("TopalServerAPI.Payment")

payment.PayInvoice(invoice1)

payment.PayInvoice(invoice2)







'load accounts to have posibility to search account by code

errCode = Manager.LoadAccounts()

if (errCode <> 0) then

 MsgBox(Manager.GetErrorMessage(errCode))

end if

'search for account by code to set payment.AccountFID

Set account = Manager.FindAccount(paymentAccCode)



' ----------------------- IMPORTANT INFO

'we have to set payment.AccountFID if payment.totalAmount of payment <> 0

'in case payment.totalAmount == 0 - i can not to set payment.AccountFID, like in this example

'payment.AccountFID = account.ID



payment.Transaction.DocDate = "31.12.2012"



'try to save payment

errCode = Manager.SaveManualPayment(payment)

if (errCode <> 0) then

	MsgBox(Manager.GetErrorMessage(errCode))

else

	MsgBox("manual payment saved succesfully")

end if















'Logout and close connection

errCode = Manager.Logout()

if (errCode <> 0) then

	MsgBox(Manager.GetErrorMessage(errCode))

else

	MsgBox("logout succesfully")

end if



Manager.Close()